#include"definitions.h"
#include <vector>
#include <queue>
#include <boost/graph/graph_utility.hpp>

using namespace std;
using namespace boost; 

void bfs(myGraph& graph,  vector<int>& BFS_vert){

	eIt ei, ei_end;
	vIt vi, vi_end;
	vIt s=vertices(graph).first;
	unsigned int level;

	bool *visited = new bool[num_vertices(graph)];
	vector<int> *vert_on_level = new vector<int>[num_vertices(graph)];
	queue<int> *Q = new queue<int>[num_vertices(graph)+1];
	bool **visited_edge = new bool*[num_vertices(graph)];
	for (size_t i=0; i<num_vertices(graph); i++)
	  visited_edge[i] = new bool [num_vertices(graph)];
	
	for(tie(ei, ei_end)=edges(graph); ei!=ei_end; ++ei){
		visited_edge[source(*ei,graph)][target(*ei,graph)]=false;
		visited_edge[target(*ei,graph)][source(*ei,graph)]=false;
	}
	
	Q[0].push(*s);
	for(tie(vi, vi_end)=vertices(graph); vi!=vi_end; ++vi){
		visited[*vi]=false;
	}

	visited[*s]=true;
	
	level = 0;
	vert_on_level[level].push_back(*s);

	while(!Q[level].empty()){
		int u = Q[level].front();
		visited[u]=true;
		Q[level].pop();
		aIt ai,ai_end;
		for(tie(ai, ai_end)=adjacent_vertices(u,graph);ai!=ai_end; ++ai){
			if(!visited_edge[u][*ai] && !visited_edge[*ai][u] ){
				visited_edge[u][*ai]=true;
				visited_edge[*ai][u]=true;

				if(!visited[*ai]){
					vert_on_level[level+1].push_back(*ai);
					 Q[level+1].push(*ai);
					 visited[*ai]=true;
				}
			}	
		}
		
		if(Q[level].empty()) level+=1;
	}
	
	for(unsigned int l=0; l<level; ++l)
		for(unsigned int i=0; i<vert_on_level[l].size();++i)
			BFS_vert.push_back(vert_on_level[l][i]);
	
	/*for(unsigned int l=0; l<level; ++l){
		cout << "\n\nlevel " << l << " -> ";
		for(unsigned int i=0; i<vert_on_level[l].size();++i){
		    cout << "\n v " << vert_on_level[l][i] ;
		}
	}*/

	/* cleanup memory */
	delete [] visited;
	delete [] vert_on_level;
	delete [] Q;

	for (size_t i=0; i<num_vertices(graph); i++)
	  delete [] visited_edge[i];

	delete [] visited_edge;
}
