//#include <set>
#include "definitions.h"
#include "blow_down.h"
#include "print_stuff.h"
#include <boost/graph/graph_utility.hpp>
#include <boost/graph/copy.hpp>
//#include <boost/property_map.hpp>
#include <boost/property_map/property_map.hpp>

#include <iostream>
#include <fstream>
#include <string>
//#include <sstream>

using namespace std;
using namespace boost;


//***************************************************************************

int GCD(int a, int b){
   int r;

   while(b!=0)
    {
       r=a%b;
       a=b;
       b=r;
    }
   return a;
}

//***************************************************************************
//finds ralion S and fill vector c with info which vertex is in which S class
VecOfSets find_S(myGraph& G , vector<int>& c){
   VecOfSets A(num_vertices(G)),S;
   S.clear();
   vector<int> t(num_vertices(G));
   set<int>::iterator its1,its2;
   vIt vi,viend;
   aIt ai,aiend;
   int i,j,which,n=num_vertices(G);

   i=which=0;
   for(tie(vi,viend)=vertices(G);vi!=viend;++vi)
    {
       set<int> s;
       s.insert(*vi);
       for (tie(ai,aiend)=adjacent_vertices(*vi,G);ai!=aiend;++ai)   s.insert(*ai);
	   
       A[*vi]=s; //stores info about neighbours of vertices (vertex i neighbours are in set s)
    }
	
   //for(tie(vi,viend)=vertices(G);vi!=viend;++vi) showSet(A[*vi]);
   
	   
	   
  for (i=0;i<n;i++)
    if (t[i]==0)
     {
        set<int> s;       
        t[i]=1;      //<---vertex -i- is in some S class
        c[i]=which;  //<---exactly in -which- class
        s.insert(i);       
        for (j=i+1;j<n;j++)
         {                               
            if (t[j]==0)
             {   
                for (its1=A[i].begin(),its2=A[j].begin();its1!=A[i].end();++its1,++its2)
                 if (*its1!=*its2) break;  //comparing whether all neighburs are the same
                if ( ( its2==A[j].end() ) && ( its1==A[i].end() ) )
                 {           // if yes, vertices are in the same S class
                    t[j]=1;
                    c[j]=which;
                    s.insert(j);
                 } 
             }
         }  
        S.push_back(s);  //stores info about S classes (sets -s- are equivalence classes )
        which++;    
     }   
   return S;
}

//***************************************************************************
//find greatest common divisor of cardinality of S classes
int GCDofSets(VecOfSets& S){
   vosIt itm;
   int value;    

   value=(*S.begin()).size(); //-value- =size of first equivalence class
   for (itm=++S.begin();itm!=S.end();++itm)
    {
       value=GCD(value,(*itm).size());
       if (value==1) break;
    }
	
   //cout << "\n\ngcd=" << value;
   return value;
}

//***************************************************************************
//finds G/S with given relation S, vector c stores info which vertex is in which S class
//vector howmany will store info how many vertices in real graph stands for each vertex in G/S
myGraph GoverS(myGraph& G , VecOfSets& S , vector<int>& c , vector<int>& how_many, int gcd) {                                                    
   vIt vi,viend;
   aIt ai,aiend;
   vosIt itm;
   int n=S.size();
   myGraph GS(n);
   int edgeID=0; 
   
   
   
   for(tie(vi,viend)=vertices(G);vi!=viend;++vi)
    for (tie(ai,aiend)=adjacent_vertices(*vi,G);ai!=aiend;++ai)
     //if two neighbours are in different S classes we create an edgde in graph G/S
     if ((c[*vi]!=c[*ai]) && (! (edge(c[*vi],c[*ai],GS).second) ) )  
	 {
		 add_edge(c[*vi],c[*ai],edgeID,GS);
		 ++edgeID;
	 }
   for (int i=0;i<n;i++)
    how_many[c[*(S[i].begin())]]=S[i].size(); 
	
   	for(unsigned int i=0; i<how_many.size(); ++i)
		how_many[i]=how_many[i]/gcd;
	
    
   return GS;
}

//***************************************************************************
//finds G' of G, given relation S and number of S classes (size)
myGraph Gprim(myGraph& G , VecOfSets& S, int& gcd)  {                                                   
   sGraph copy,subPrime;   //copy stores graph G as subgraph, subPrime is graph G prime 
   myGraph myPrime;        // myPrime is a graph G prime as myGraph   
   set<int>::iterator si;
   //int gcd;
   unsigned int i,j,d,size=S.size();
   
   
   
   copy_graph(G,copy);
   subPrime=copy.create_subgraph(); 
   gcd=GCDofSets(S);
   
   for (i=0;i<size;i++)
    {
       d=S[i].size()/gcd;
       j=1;
	  // cout << "d = " << d << endl;
       for(si=S[i].begin();j<=d;++si,++j)
        add_vertex(*si,subPrime);
	
    }
	/*cout << "sub .. " << endl;
	myEdgeID_sub edge_id3 = get(edge_index, subPrime);
	eIt ei, ei_end;
	for(tie(ei,ei_end)=edges(subPrime); ei!=ei_end; ++ei){
		cout << "\nedgeID" << get(edge_id3, *ei);
	}cout << endl;
		*/
   copy_graph(subPrime,myPrime);
   
   /*cout << "copy sub .. " << endl;
	myEdgeID edge_id = get(edge_index, myPrime);
	//eIt ei, ei_end;
	for(tie(ei,ei_end)=edges(myPrime); ei!=ei_end; ++ei){
		cout << "\nedgeID" << get(edge_id, *ei);
	}cout << endl;
	*/	
   //print_graph(myPrime);*/
  
   return myPrime;
}

//***************************************************************************

