#pragma once
#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/subgraph.hpp>


typedef boost::adjacency_list
<
boost::vecS, 
boost::vecS, 
boost::undirectedS, 
//boost::no_property, 
boost::property<boost::vertex_name_t, int>,
boost::property<boost::edge_index_t, std::size_t, 
boost::property< boost::edge_weight_t, int, 
boost::property< boost::edge_weight2_t, int > > > 
> myGraph;			

typedef boost::subgraph< myGraph > sGraph;

typedef std::vector<int> vect;
typedef std::vector<int>::iterator iter;
typedef std::vector<int>::iterator vecIt;

typedef std::vector< std::set<int> > VecOfSets;
typedef std::vector< std::set<int> >::iterator vosIt;
typedef std::set< std::set<int> >::iterator sosIt;

typedef std::vector< std::vector<int> > matrix;
typedef std::vector< std::vector<int> >::iterator row; 

typedef boost::graph_traits<myGraph>::vertex_iterator vIt;
typedef boost::graph_traits<myGraph>::edge_iterator eIt;
typedef boost::graph_traits<myGraph>::adjacency_iterator aIt;

typedef boost::graph_traits<myGraph>::vertex_descriptor vD;
typedef boost::graph_traits<myGraph>::edge_descriptor eD;

typedef std::pair<boost::graph_traits<myGraph>::vertex_descriptor, boost::graph_traits<myGraph>::vertex_descriptor> myEdge;
typedef boost::property_map<myGraph, boost::edge_index_t>::type myEdgeID;
typedef boost::property_map<sGraph, boost::edge_index_t>::type myEdgeID_sub;
typedef boost::property_map<myGraph, boost::edge_weight_t >::type myEdgeW;


typedef boost::property_map<myGraph, boost::vertex_name_t>::type myVertexName;
typedef boost::property_map<sGraph, boost::vertex_name_t>::type myVertexName_sub;


