#include "pomp_up.h"
#include "test_and_combine.h"
#include "init_stuff.h"
#include "print_stuff.h"
//#include "test_and_combine.h"
#include <boost/graph/graph_utility.hpp>
#include <boost/graph/connected_components.hpp>
#include <boost/graph/copy.hpp>
#include <iostream>
#include <math.h>

using namespace std;  
using namespace boost;



int GCD2(int a, int b)
{
   int r;

   while(b!=0)
    {
       r=a%b;
       a=b;
       b=r;
    }
   return a;
}

int GCD2(vect v)
{
   int gcd=*(v.begin());
   vecIt vi;
   
   for (vi=++v.begin();vi!=v.end();++vi)
    {
        if (gcd==1) break;
        gcd=GCD2(gcd,*vi);
    }
   return gcd;
}

void new_factor(int i, int sum, vect gcd, matrix numbers, vector<myGraph>& new_factors, vector<myGraph>& factors){
	
	vIt vi, viend;
	aIt ai, aiend;
	vecIt pi, qi;
	
	
	for (int j=0;j<sum;j++) add_vertex(new_factors[i]); //given the info how many vertices are in new factor
                                                        //this is done if one wants to run function
                                                        // edges(...).second  later  
		for(tie(vi,viend)=vertices(factors[i]);vi!=viend;++vi)
        {   
            if (gcd[*vi]>1)//if in vertex was packed more then one vertex create a complete
                           //graph insted of one vertex
             for (int l=numbers[*vi][0];l<numbers[*vi][0]+gcd[*vi];l++)
              for (int k=l+1;k<numbers[*vi][0]+gcd[*vi];k++)
               if (!edge(l,k,new_factors[i]).second) add_edge(l,k,new_factors[i]);
            //add vertices according to adjacency list of factors and numbers[][] in new factors   
            for (tie(ai,aiend)=adjacent_vertices(*vi,factors[i]);ai!=aiend;++ai)    
             for (pi=numbers[*vi].begin();pi!=numbers[*vi].end();++pi)
              for (qi=numbers[*ai].begin();qi!=numbers[*ai].end();++qi)
               if (!edge(*pi,*qi,new_factors[i]).second) add_edge(*pi,*qi,new_factors[i]); 
         } 
}


void pomp_up(vect& hm , matrix& fibers , vector<myGraph>& factors , bool& b, vector<myGraph>& new_factors)
{  
    int i,j,l,k,sum,num,mult;
    int f=factors.size();
    //vector<myGraph> new_factors(f);//we store here new factors(after pumping up)
	new_factors.clear();
	new_factors.resize(f);
    vecIt pi,qi;
    matrix values(f);//stores info how many vertices are actually packed in each vertex of factor i 
	matrix vertex_fiber(f);
	//vect vert;
    vIt vi,viend;
    aIt ai,aiend;
    vect values2(hm.size());
	
	for (i=0;i<f;i++){
		k=0;
		
		for (tie(vi, viend)=vertices(factors[i]); vi!=viend; ++vi)
         {	
		//	cout << "\nv " << *vi << " k " << k;
			vertex_fiber[i].push_back(k);
			++k;
		 }
	}

	for (i=0;i<f;i++){
		vect gcd(num_vertices(factors[i]),1);
		matrix numbers(num_vertices(factors[i]));
		num=sum=0;
		values[i].resize(num_vertices(factors[i]));
		
		for (tie(vi, viend)=vertices(factors[i]); vi!=viend; ++vi)
		{	
			vect v;
			int ver=*vi;
			for (unsigned int m=0;m<fibers.size();m++)
				if (fibers[m][i]==ver)            //"sizes"-how many vertices is "packed" in this vertec
					v.push_back(hm[m]); // in v are "sizes" of vertices of a given fiber
			  
			gcd[*vi]=GCD2(v);    // greatest common divisor of all numbers in v - this is the number that
                                 // tells You how many vertices are actually packed in one vertex in the factor
			sum=sum+gcd[*vi];   
			for (l=0;l<gcd[*vi];l++)
				numbers[*vi].push_back(num++);  
				
			values[i][*vi]=gcd[*vi];
		}  
		new_factor(i,sum, gcd, numbers, new_factors, factors); //pomped up factors
	}
    
	vecIt it;
	
	j=0; 
	b=true;
	for (pi=hm.begin();pi!=hm.end();++pi,j++) //checking whether new factors give me right graph
	{	
		mult=1;
		for (i=0;i<f;i++) 
			mult=mult*values[i][fibers[j][i]];
			
		//cout << endl << *pi << "-" << mult;
		if (*pi!=mult) { 
			b=false; 
			break;
		} 
	} 
}


int POMPUP_check_and_combine(myGraph& G, myGraph& CartSk, myGraph& CartSkEdgeID, myGraph& CartRelGraph, 
							 vector< vector<int> >& coord_vert, vector<int>& component, int& numFactors,
							 vector<myGraph>& new_factors, vect& hm){
	/**loop due to isomorphismTest in NICE-paper**/
	
	numFactors = connected_components(CartRelGraph, &component[0]);
	
	if(numFactors == 1)
		return 0;
	
	set<int> S,I,J;
	for(int i=0; i<numFactors; ++i){
		I.insert(i);
		J.insert(i);
	}
	
//	cout << endl << "J="; showSet(J);
	vector< set<int> >saveS;
	vector< set<int> >tmpS;
	
	myGraph tmp_CartSk;
	myGraph tmp_CartSkEdgeID;
	myGraph tmp_CartRelGraph;
	myGraph tmp_G;
	

	for(int L=1; L<=numFactors; ++L){
		if(L>int(J.size())) break;
		vector<int> elements_of_J;
		vector< set< int > > Subsets_Of_J;
		vector< set< int > > length_L_subsets;
		vector<int> bin;//bin.clear();

		Subsets(L, J,elements_of_J,Subsets_Of_J,length_L_subsets,bin);
		
		for(unsigned int j = 0; j<length_L_subsets.size(); j++){
			
			clear_graph(tmp_CartSk);
			clear_graph(tmp_CartSkEdgeID);
			clear_graph(tmp_CartRelGraph);
			clear_graph(tmp_G);
			copy_graph(CartSk,tmp_CartSk);
			copy_graph(CartSkEdgeID,tmp_CartSkEdgeID);
			copy_graph(CartRelGraph,tmp_CartRelGraph);
			copy_graph(G,tmp_G);
	
			S.clear();
			
			S = length_L_subsets[j];
			set<int> I_minus_S; I_minus_S.clear();
			init_IminusS(I,S,I_minus_S);
		
			if(!S.empty() && !I_minus_S.empty()){
			
				tmpS.clear();
				tmpS.push_back(S);
				tmpS.push_back(I_minus_S);
				
				
				vector<myGraph> tmp_new_factors;
				tmp_new_factors.clear();
				for(unsigned int i = 0; i<new_factors.size();i++){
					tmp_new_factors.push_back(new_factors[i]);
				}
				
				vector< int > tmp_component;
				tmp_component = component;
				vector< vector<int> > tmp_coord_vert;
				tmp_coord_vert = coord_vert;
				
				
				combineFactors(tmp_CartRelGraph, tmp_G,tmpS, tmp_component,tmp_coord_vert,
							   tmp_CartSk, tmp_CartSkEdgeID, tmp_new_factors);
	
				
								

				vector<myGraph> tmp_bothFactors;
				tmp_bothFactors.clear();
				tmp_bothFactors.push_back(tmp_new_factors[0]);

				tmp_bothFactors.push_back(tmp_new_factors[1]);

				bool pompup_succeed;
				pomp_up(hm, tmp_coord_vert, tmp_new_factors, pompup_succeed, tmp_bothFactors);
				
				

				if(pompup_succeed){
				//	cout << endl << "############################";
				//	cout << endl << "S" << j << " = "; showSet(S);
					//cout << endl << "IminusS  = "; showSet(I_minus_S);cout << endl;
				//	cout << "saveS";
					
					saveS.push_back(S);
					set<int> oldJ;oldJ.clear();
					oldJ=J;J.clear();
					
					init_IminusS(oldJ,S,J);
					

					Subsets(L, J,elements_of_J,Subsets_Of_J,length_L_subsets,bin);
					j = 0;
				}
			}
		}
	}
	

	if(!J.empty()) saveS.push_back(J);
	combineFactors(CartRelGraph, G,saveS, component, coord_vert,
				   CartSk, CartSkEdgeID, new_factors);
	
	return 0;
}



